Unit afj0e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAF13_p;

procedure afj0e(var B :Array of Extended; var C :Array of Extended;
                N :Integer; var IERR :Integer);

implementation

procedure afj0e(var B :Array of Extended; var C :Array of Extended;
                N :Integer; var IERR :Integer);
var
I :Integer;
D,BI,CI,S,R,SB,SC,S1,S2 :Extended;
const
SYS056 :Extended = 5.56268464627e-308;
label
_1,_2,_3,_4,_5,_6;
begin
IERR := 0;
C[0] := 1.e0;
D := 1.e0;
if ( N = 1 ) 
 then goto _6;
for I:=2 to N do
 begin
  BI := B[I-1];
  CI := C[I-1];
  SB := Sqrt(Abs(BI));
  SC := Sqrt(Abs(CI));
  S := SB*SC;
  B[I-1] := S;
  S1 := 0.e0;
  S2 := 0.e0;
  if ( BI <> 0.e0 ) 
   then S1 := Sign(1.e0,BI);
  if ( CI <> 0.e0 ) 
   then S2 := Sign(1.e0,CI);
  if ( S1 <> S2 ) 
   then goto _5;
  if ( S1 = 0.e0 ) 
   then goto _2;
  if ( IERR = 68 ) 
   then goto _4;
  R := SC/SB;
  if ( R*SYS056*D < 1.e0 ) 
   then goto _1;
  IERR := 68;
  goto _4;
_1:
  D := D*R*S2;
  goto _3;
_2:
  D := 1.e0;
_3:
  C[I-1] := D;
  if ( D = 0.e0 ) 
   then IERR := 68;
_4:
 end;
goto _6;
_5:
IERR := 66;
if ( S = 0.e0 ) 
 then IERR := 67;
_6:
if ( IERR <> 0 ) 
 then UTAF13(IERR,3);
end;

end.
